## Copyright (C) 2004 Eric Chassande-Mottin
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

% this is a small check to see whether the WVs satisfy Moyal

N=256;
x1=randn(N,1);
x2=randn(N,1);

e=sum(x1.*x2)^2;

tfd1= dwv0(x1); tfd2= dwv0(x2);
e0=sum(sum(tfd1.*tfd2))/2/N;

tfd1= dwv(x1);tfd2= dwv(x2);
ee=sum(sum(tfd1.*tfd2))/2/N;

tfd1= dwv1(x1);tfd2= dwv1(x2);
e1=sum(sum(tfd1.*tfd2))/4/N;

printf('even N=%d -----------------------------------------------\n',N);
printf('direct computation: sum(x1.*x2)^2=%2.1f\n',e);
printf('Claasen/Mecklenbrauker: Moyal with dwv0=%2.1f [rel. diff.=%d %%]\n',e0,round(100*abs(e0-e)/e));
printf('Chassande/Pai: Moyal with dwv=%2.1f [rel. diff.=%d %%]\n',ee,round(100*abs(ee-e)/e));
printf('Peyrin/Prost: Moyal with dwv1=%2.1f [rel. diff.=%d %%]\n',e1,round(100*abs(e1-e)/e));

N=255;
x1=randn(N,1);
x2=randn(N,1);

e=sum(x1.*x2)^2;

tfd1= dwv2(x1);tfd2= dwv2(x2);
e2=sum(sum(tfd1.*tfd2))/N;

printf('\nodd N=%d  -----------------------------------------------\n',N);
printf('direct computation: sum(x1.*x2)^2=%2.1f\n',e);
printf("Richman et al./O'Neill et al.: Moyal with dwv2=%2.1f [rel. diff.=%d %%]\n",e2,round(100*abs(e2-e)/e));

